clear
close all

I=imread('/Users/marcel/Documents/MATLAB/0-images-exemples/house.jpg');
I=rgb2gray(I);
I=double(I)/255.0;
Ib=imnoise(I, 'salt & pepper', 0.01);

%hi = [-1 -1 -1;-1 9 -1;-1 -1 -1]
hi=-ones(3,3); hi(2,2)=9

I_hi = filter2(hi, I);
I_hi2 = filter2(hi, I_hi);
I_hi3 = filter2(hi, I_hi2);

Ib_hi = filter2(hi, Ib);
Ib_hi2 = filter2(hi, Ib_hi);
Ib_hi3 = filter2(hi, Ib_hi2);

figure(1), colormap('gray')

subplot(2,4,1), imshow(I), title('image originale')
subplot(2,4,2), imshow(I_hi), title('filtrage passe-haut, 1 fois')
subplot(2,4,3), imshow(I_hi2), title('filtrage passe-haut, 2 fois')
subplot(2,4,4), imshow(I_hi3), title('filtrage passe-haut, 3 fois')

subplot(2,4,5), imshow(Ib), title('image bruite')
subplot(2,4,6), imshow(Ib_hi), title('filtrage passe-haut, 1 fois')
subplot(2,4,7), imshow(Ib_hi2), title('filtrage passe-haut, 2 fois')
subplot(2,4,8), imshow(Ib_hi3), title('filtrage passe-haut, 3 fois')

% version avec boucle for :

figure(2)

Ih = I;
subplot(2,4,1), imshow(I), title('image originale')
for n=1:3
    Ih = filter2(hi, Ih);
    subplot(2,4,n+1), imshow(Ih)
    title(['filtrage passe-haut ',int2str(n),' fois'])
end

Ih = Ib;
subplot(2,4,5), imshow(I), title('image bruite')
for n=1:3
    Ih = filter2(hi, Ih);
    subplot(2,4,n+5), imshow(Ih)
    title(['filtrage passe-haut ',int2str(n),' fois'])
end