clear
close all

% image de la petite maison
I=imread('/Users/marcel/Documents/MATLAB/0-images-exemples/house.jpg');
I=rgb2gray(I);
I=double(I)/255.0;

%---
% bruit poivre et sel  hauteur de 10% des px
Ib=imnoise(I, 'salt & pepper', 0.1);

% dbruitage par le filtre mdian
Imed=medfilt2(Ib);

% dbruitage par la moyenne glissante 3x3
Im3=filter2(ones(3,3)/9.,Ib);

% dbruitage par la moyenne glissante 5x5
Im5=filter2(ones(5,5)/25.,Ib);

% figure
figure
subplot(2,3,1), imshow(I), title('image de dpart')
subplot(2,3,2), imshow(Ib), title('bruit p&s')
subplot(2,3,4), imshow(Imed), title('bruit p&s + filtrage mdian')
subplot(2,3,5), imshow(Im3), title('bruit p&s + moy. gliss. 3x3')
subplot(2,3,6), imshow(Im5), title('bruit p&s + moy. gliss. 5x5')